<!DOCTYPE html>
<html lang="en">

<head>
	<title>Ofice CRUD</title>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">

	<link rel="stylesheet" href="mystyle.css">
	<script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.24.0/moment.min.js"></script>
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>

	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
	<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />


	<!-- Import Datatable sau jquery -->
	<!-- Import them style bootstrap cho datatable -->
	<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
	<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>

<body>

	<div class="container">
		<h2 style="text-align: center;">Quản trị Office</h2>

		<!-- Create voucher modal -->
		<div>
			<div id="create-office-modal" class="modal fade" tabindex="-1">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title" id="h5-modal-title">Create new office</h5>
							<button class="close" data-dismiss="modal">&times;</button>
						</div>
						<div class="modal-body">
							<form>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>city</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-city" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>phone</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-phone" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>addressLine</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-addressLine" name="note" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>state</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-state" name="note" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>country</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-country" name="note" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>teritory</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-teritory" name="note" class="form-control">
									</div>
								</div>




							</form>
						</div>
						<div class="modal-footer">
							<button class="btn btn-secondary" id="btn-create-cancel"
								data-dismiss="modal">Cancel</button>
							<button class="btn btn-primary" id="btn-create-office">Create Office</button>
						</div>
					</div>
				</div>
			</div>
		</div>

		<!-- Update voucher modal -->
		<div>
			<div id="update-customer-modal" class="modal fade" tabindex="-1">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title" id="h5-modal-title">Update Office</h5>
							<button class="close" data-dismiss="modal">&times;</button>
						</div>
						<div class="modal-body">
							<form>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>city</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-city-update" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>phone</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-phone-update" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>addressLine</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-addressLine-update" name="note"
											class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>state</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-state-update" name="note" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>country</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-country-update" name="note" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>teritory</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-teritory-update" name="note" class="form-control">
									</div>
								</div>




							</form>
						</div>
						<div class="modal-footer">
							<button class="btn btn-secondary" id="btn-create-cancel"
								data-dismiss="modal">Cancel</button>
							<button class="btn btn-primary" id="btn-update-office">Update Office</button>
						</div>
					</div>
				</div>
			</div>
		</div>

		<!-- Delete confirm modal -->
		<div>
			<div class="modal fade" tabindex="-1" id="delete-modal">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title" id="h5-modal-title">Office Delete Confirmation</h5>
							<button class="close" data-dismiss="modal">&times;</button>
						</div>
						<div class="modal-body">
							<label>Bạn có chắc chắn muốn xóa office này không?</label>
						</div>
						<div class="modal-footer">
							<button class="btn btn-danger" id="btn-confirm-delete-office">Confirm</button>
							<button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
						</div>
					</div>
				</div>
			</div>
		</div>
		<button class="btn btn-success " id="create-office">Add Customer</button>
		<table class="table table-bordered table-striped table-hover" id="office-table">
			<thead>
				<tr>
					<th>STT</th>
					<th>city</th>
					<th>phone</th>
					<th>addressLine</th>
					<th>state</th>
					<th>country</th>
					<th>teritory</th>

					<th>Action</th>
				</tr>
		</table>
	</div>
	<script>
		/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
		// Biến mảng hằng số chứa danh sách tên các thuộc tính
		const gOFFICE_COLS = ["id", "city", "phone", "addressLine", "state", "country", "teritory", "action"];

		// Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
		const gOFFICE_STT_COL = 0;
		const gOFFICE_CITY_COL = 1;
		const gOFFICE_PHONE_COL = 2;
		const gOFFICE_ADDRESS_COL = 3;
		const gOFFICE_STATE_COL = 4;
		const gOFFICE_COUNTRY_COL = 5;
		const gOFFICE_TERITORY_COL = 6;
		const gOFFICE_ACTION_COL = 7;


		var table = $("#office-table").DataTable({
			columns: [
				{ data: gOFFICE_COLS[gOFFICE_STT_COL] },
				{ data: gOFFICE_COLS[gOFFICE_CITY_COL] },
				{ data: gOFFICE_COLS[gOFFICE_PHONE_COL] },
				{ data: gOFFICE_COLS[gOFFICE_ADDRESS_COL] },
				{ data: gOFFICE_COLS[gOFFICE_STATE_COL] },
				{ data: gOFFICE_COLS[gOFFICE_COUNTRY_COL] },
				{ data: gOFFICE_COLS[gOFFICE_TERITORY_COL] },
				{ data: gOFFICE_COLS[gOFFICE_ACTION_COL] },

			],
			columnDefs: [
				{ // định nghĩa lại cột action
					targets: gOFFICE_ACTION_COL,
					defaultContent: `
					<i class="fas fa-edit edit-office"></i>
					<i class="fas fa-trash-alt delete-office"></i>
			  
			`
				}
			]
		})
		var gRowSelected = ''
		var glistAlbum = [];
		var gOfficeIdSelected = '';
		var gRowCustomerSelected = '';
		var glistAlbumValidateUpdate = [];
		/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
		$(document).ready(function () {
			onPageLoading();
			//create new album
			$('#create-office').on('click', function () {

				onBtnAddOfficeClick();
			})
			$('#btn-create-office').on('click', function () {

				onBtnCreateOfficeOnModalClick();
			})
			//edit album
			$('#office-table').on('click', '.edit-office', function () {

				onBtnEditOfficeClick(this);
			})
			$('#btn-update-office').on('click', function () {
				onBtnUpdateOnModalClick()
			})

			//xóa album
			$('#office-table').on('click', '.delete-office', function () {

				onBtnDeleteOfficeClick(this);
			})
			$('#btn-confirm-delete-office').on('click', function () {

				onBtnConfirmOnDeleteModalClick(this);
			})




		})
		/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
		//hàm gọi api load danh sách album từ server khi tải trang
		function onPageLoading() {
			console.log('làm toi day')
			$.ajax({
				url: "http://localhost:8080/office/all",
				type: "GET",
				dataType: "json",
				success: function (res) {
					glistAlbum = res
					console.log('check data get all office from server', res);
					table.clear();
					table.rows.add(res);
					table.draw();
				},
				error: function (err) {
					console.log(err.response);
				}
			})
		}
		//hàm thực hiện khi nhấn nút add new album
		function onBtnAddOfficeClick() {

			$("#create-office-modal").modal("show");

		}
		//hàm thực hiện khi nhấn create album trên modal
		function onBtnCreateOfficeOnModalClick() {
			createNewOffice();
			$("#create-office-modal").modal("hide");
		}
		//hàm thực hiện khi lúc nút edit
		function onBtnEditOfficeClick(paramButton) {
			$("#update-customer-modal").modal("show");
			gOfficeIdSelected = getCustomerIdFromButton(paramButton)

			console.log('check id office selected', gOfficeIdSelected)
			callApiToGetOfficeById(gOfficeIdSelected)
		}
		//hàm thực hiện khi nhấn nút update trên modal
		function onBtnUpdateOnModalClick() {
			updateOffice(gOfficeIdSelected);
			$("#update-customer-modal").modal("hide");

		}
		//Hàm thực hiện khi nhấn nút delete
		function onBtnDeleteOfficeClick(paramButton) {
			$("#delete-modal").modal("show");
			gOfficeIdSelected = getCustomerIdFromButton(paramButton)

		}
		//hàm thực hiện khi nhấn nút confirm trên delete modal
		function onBtnConfirmOnDeleteModalClick() {
			deletedOffice();
			$("#delete-modal").modal("hide");

		}
		/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
		//hàm trả ra id album khi nhấn nút edit
		function getCustomerIdFromButton(paramButton) {
			var vTableRow = $(paramButton).parents("tr");
			gRowCustomerSelected = table.row(vTableRow).data();
			console.log(gRowCustomerSelected.id);
			return gRowCustomerSelected.id;
		}
		//hàm gọi api để lấy album cần edit theo id
		function callApiToGetOfficeById(id) {

			$.ajax({
				url: `http://localhost:8080/office/details/${id}`,
				async: false,
				type: "GET",
				dataType: "json",
				success: function (res) {
					console.log('check data office need to update ress', res);
					if (glistAlbum && glistAlbum.length > 0) {
						glistAlbum.map((item, index) => {
							if (item.id == res.id) {
								glistAlbum.splice(index, 1)
							}
						})
					}
					showDataUpdateOnForm(res);
				},
				error: function (err) {
					console.log(err.response);
				}
			})

		}
		//hàm hiển thị data lên form edit
		function showDataUpdateOnForm(paramAlbum) {




			$('#input-city-update').val(paramAlbum.city);
			$('#input-phone-update').val(paramAlbum.phone);
			$('#input-addressLine-update').val(paramAlbum.addressLine);
			$('#input-state-update').val(paramAlbum.state);
			$('#input-country-update').val(paramAlbum.country);
			$('#input-teritory-update').val(paramAlbum.teritory);

		}

		function updateOffice(paramOfficeId) {
			let objData = {

				city: "",

				phone: '',

				addressLine: '',

				state: '',

				country: '',

				teritory: ''
			}
			let objDataFromForm = getDataOnFormUpdate(objData);
			callApiToUpdateData(paramOfficeId, objDataFromForm);
			onPageLoading();
			// var vCheck = validateDataOnform(objDataFromForm);
			// if (vCheck) {
			// 	let albumExist = '';
			// 	if (glistAlbum && glistAlbum.length > 0) {

			// 		for (let i = 0; i < glistAlbum.length; i++) {
			// 			if (glistAlbum[i].albumCode == objDataFromForm.albumCode) {
			// 				alert("Album existed");
			// 				albumExist = glistAlbum[i];
			// 				console.log('Album existed', albumExist)
			// 			}
			// 		}

			// 	}
			// 	if (albumExist == '') {

			// 		callApiToUpdateData(paramOfficeId, objDataFromForm);
			// 		onPageLoading();
			// 	}



			// }
		}




		//hàm thu thập dư liệu trên form update
		function getDataOnFormUpdate(obj) {


			obj.city = $('#input-city-update').val();
			obj.phone = $('#input-phone-update').val();
			obj.addressLine = $('#input-addressLine-update').val();
			obj.state = $('#input-state-update').val();
			obj.country = $('#input-country-update').val();
			obj.teritory = $('#input-teritory-update').val();
			return obj
		}
		//hàm gọi api để update album
		function callApiToUpdateData(id, paramOrderObject) {
			$.ajax({
				async: false,
				url: `http://localhost:8080/office/update/${id}`,
				type: 'PUT',
				async: false,
				contentType: "application/json;charset=UTF-8",
				data: JSON.stringify(paramOrderObject),
				success: function (res) {
					console.log('check data update response', res);

				},
				error: function (error) {
					console.assert(error.responseText)
				}
			})
		}

		//save new album
		function createNewOffice() {
			let objData = {

				city: "",

				phone: '',

				addressLine: '',

				state: '',

				country: '',

				teritory: ''

			}
			let objDataFromForm = getDataOnForm(objData);
			callApiToPostData(objDataFromForm);
			onPageLoading();
			// var vCheck = validateDataOnform(objDataFromForm);
			// if (vCheck) {
			// 	if (glistAlbum && glistAlbum.length > 0) {
			// 		glistAlbum.map(item => {
			// 			if (item.albumCode == objDataFromForm.albumCode) {
			// 				alert("Album existed")
			// 			} else {
			// 				console.log('check data post', objDataFromForm)
			// 				callApiToPostData(objDataFromForm);
			// 				onPageLoading();

			// 			}
			// 		})
			// 	}

			// }

		}
		//hàm thực hiện validate dữ liệu trên form
		// function validateDataOnform(paramObjData) {
		// 	if (!paramObjData.albumCode) {
		// 		alert('Missing album code')
		// 		return false;
		// 	}
		// 	if (!paramObjData.albumName) {
		// 		alert('Missing album name')
		// 		return false;
		// 	}
		// 	if (!paramObjData.description) {
		// 		alert('Missing description')
		// 		return false;
		// 	}
		// 	return true;


		// }
		//hàm thu thập dư liệu trên form
		function getDataOnForm(obj) {

			obj.city = $('#input-city').val();
			obj.phone = $('#input-phone').val();
			obj.addressLine = $('#input-addressLine').val();
			obj.state = $('#input-state').val();
			obj.country = $('#input-country').val();
			obj.teritory = $('#input-teritory').val();

			return obj
		}
		//hàm gọi api để tạo album mới
		function callApiToPostData(paramOrderObject) {
			$.ajax({
				async: false,
				url: `http://localhost:8080/office/create`,
				type: 'POST',
				async: false,
				contentType: "application/json;charset=UTF-8",
				data: JSON.stringify(paramOrderObject),
				success: function (res) {

					console.log('check data post response', res);

				},
				error: function (error) {
					console.assert(error.responseText)
				}
			})
		}
		function deletedOffice() {
			callApiToDeleteData(gOfficeIdSelected);
			onPageLoading();
		}
		function callApiToDeleteData(id) {
			$.ajax({
				async: false,
				url: `http://localhost:8080/office/delete/${id}`,
				type: 'DELETE',
				async: false,
				// contentType: "application/json;charset=UTF-8",
				// data: JSON.stringify(paramOrderObject),
				success: function (res) {
					alert('Delete success')

				},
				error: function (error) {
					console.assert(error.responseText)
				}
			})
		}


	</script>
</body>

</html>